C  Program for interpolating O3 AVK from look-up tables
C  Version 1.0 created on 08/02/2012 by BIRA-IASB
C  Contact: Franois Hendrick (franch@oma.be)
	PROGRAM interpolate_O3_AVK

      INTEGER n_wv,n_lat,n_month,month_nbr,flag_am_pm,n_day_max
	INTEGER n_day_int,n_o3,n_alb,n_alt,ind_lat,cc,inter_flag,dd
	INTEGER year
      PARAMETER (n_wv=5,n_lat=18,n_month=12,n_day_max=500000)
	PARAMETER (n_o3=10,n_alb=2,n_alt=60,n_alt_p=61)
	PARAMETER (n_ind_low=10,n_ind_up=10)
	INTEGER ind_low(n_ind_low),ind_up(n_ind_low),albedo_flag
	INTEGER month_nb
	REAL*8 wv_vec(n_wv),lat_vec(n_lat),alb_vec(n_alb)
	REAL*8 alt_vec(n_alt),o3_scd_effective(n_wv,n_o3),buffer(n_alt_p)
	REAL*8 o3_avk_alt(n_alt,n_wv),o3_avk_wv,year_int(n_day_max)
	REAL*8 o3_avktbl(n_alt,n_alb,n_wv,n_lat,n_month,n_o3)
	REAL*8 o3_scdtbl(n_alb,n_wv,n_lat,n_month,n_o3)
	REAL*8 daynb_vec(n_month),o3_vcd_effective(n_o3)
	REAL*8 wvl_int,lat_int,sza_int(n_day_max),ycalc,hh
	REAL*8 scd_int(n_day_max),alb_int,alt_int,o3_col_int
	REAL*8 vcd_int(n_day_max),dycalc,long_int,daynb_int(n_day_max)
	REAL*8 o3_vcd(n_o3),daynb_int_out,lat_int_out,o3_vcd_vec(n_o3)
	REAL*8 o3_avktbl_lat(n_alt,n_alb,n_wv,n_month,n_o3)
	REAL*8 o3_scdtbl_lat(n_alb,n_wv,n_month,n_o3)
	REAL*8 o3_avktbl_dn(n_alt,n_alb,n_wv,n_o3)
	REAL*8 o3_avktbl_alb(n_alt,n_wv,n_o3)
	REAL*8 o3_avk_int(n_alt)
	REAL*8 long_int_out
	REAL*8 alb_int_1,alb_int_2,alb_int_3,alb_int_4,alb_int_5
	REAL*8 alb_int_6,alb_int_7,alb_int_8,alb_int_9,alb_int_10
	REAL*8 alb_int_11,alb_int_12
	REAL*8 o3_scdtbl_dn(n_alb,n_wv,n_o3)
	REAL*8 o3_scdtbl_alb(n_wv,n_o3),alb_mat_lat(360)
	REAL*8 alb_mat(360,180)
	REAL*8 o3_avk_effective(n_alt,n_wv,n_o3)
	REAL*8 o3_avktbl_sza_int(n_wv,n_o3),long_alb_vec(360)
	REAL*8 o3_scdtbl_sza_int(n_wv,n_o3),lat_alb_vec(180)
	REAL*8 YWORK(50),Y2(50),lat_vec_work(2)
	CHARACTER*12 str_buffer
	CHARACTER*30 day_file

C  Wavelength vector
	DATA wv_vec /
     $ 440.d0, 475.d0, 510.d0, 545.d0, 580.d0/
C  Latitude vector
	DATA lat_vec /
     $ -85.d0, -75.d0, -65.d0, -55.d0, -45.d0, -35.d0, -25.d0, 
     $ -15.d0, -5.d0, 5.d0, 15.d0, 25.d0, 35.d0, 45.d0, 55.d0, 65.d0,
     $  75.d0, 85.d0/
C  Albedo vector
	DATA alb_vec /
     $ 0.d0, 1.d0/
C  Day number vector
      DATA daynb_vec /
     $ 15.d0, 46.d0, 74.d0, 105.d0, 135.d0, 166.d0, 196.d0, 
     $ 227.d0, 258.d0, 288.d0, 319.d0, 349.d0/
C  O3 VCD vector
      DATA o3_vcd_vec /
     $ 125.d0, 175.d0, 225.d0, 275.d0, 325.d0, 375.d0, 425.d0, 
     $ 475.d0, 525.d0, 575.d0/

      
C  Read O3 AVK interpolation input file
      OPEN(1,file='input_file_o3_avk.dat')
	DO i=1,3
		READ(1,*)
	ENDDO
      READ(1,*) wvl_int
	READ(1,*)
	READ(1,*) lat_int
	READ(1,*) 
	READ(1,*) long_int
	READ(1,*) 
	READ(1,*) albedo_flag
	READ(1,*) 
	READ(1,*) alb_int
	READ(1,*) 
      READ(1,100) day_file
	CLOSE(1)
  100 format(a30)

      inter_flag=1 ! interpolation only on O3 vertical columns in DU


C read SZA file

      OPEN(1,file=day_file)
	DO i=1, n_day_max
	IF(inter_flag.EQ.2) THEN
        READ(1,*,END=19) year_int(i),daynb_int(i),scd_int(i)
	ELSE
        READ(1,*,END=19) year_int(i),daynb_int(i),vcd_int(i)
	ENDIF

	ENDDO	
c     number of sza for interpolation  
  19  n_day_int = i-1
      CLOSE(1)
	
	o3_vcd=o3_vcd_vec	

C Check input parameters values


	IF(wvl_int.LT.440.d0.OR.wvl_int.GT.580.d0) THEN
	WRITE(*,*)' !! PLEASE CHOOSE WAVELENGTH IN THE 440-580 NM RANGE 
     $!!'
	STOP
	ENDIF


      IF(lat_int.LT.-90.d0.OR.lat_int.GT.90.d0) THEN
	WRITE(*,*)' !! PLEASE CHOOSE LATITUDE IN THE -90deg - +90deg 
     $RANGE !!'
	STOP
	ENDIF

	IF((alb_int.LT.0.d0.OR.alb_int.GT.1.d0).and.albedo_flag.eq.2) THEN
	WRITE(*,*)' !! PLEASE CHOOSE GROUND ALBEDO IN THE 0 - 1 
     $RANGE !!'
	STOP
	ENDIF


C Latitude check
      lat_int_out=lat_int

      IF(lat_int.LT.-85.d0) THEN
		lat_int=-84.99d0
	ELSEIF(lat_int.GE.85.d0) THEN
	    lat_int=84.99d0
	ENDIF

	DO i=1,n_lat-1
		IF(lat_int.GE.lat_vec(i).AND.lat_int.LT.lat_vec(i+1)) THEN
			ind_lat=i
		ENDIF
	ENDDO

	IF(lat_int.GE.lat_vec(n_lat)) THEN
		ind_lat=18
	ENDIF

C Longitude check
      long_int_out=long_int
	IF(long_int.LT.-179.5d0) THEN
		long_int=-179.5d0
	ELSEIF(long_int.GT.179.5d0) THEN
	    long_int=179.5d0
	ENDIF

	
C  Read O3 AVK look-up table
      IF(ind_lat.EQ.1) THEN
		OPEN(1,file='o3_avk_lat_01.dat')
	    OPEN(2,file='o3_avk_lat_02.dat')
	ELSEIF (ind_lat.EQ.2) THEN
	    OPEN(1,file='o3_avk_lat_02.dat')
	    OPEN(2,file='o3_avk_lat_03.dat')
	ELSEIF (ind_lat.EQ.3) THEN
	    OPEN(1,file='o3_avk_lat_03.dat')
	    OPEN(2,file='o3_avk_lat_04.dat')
	ELSEIF (ind_lat.EQ.4) THEN
	    OPEN(1,file='o3_avk_lat_04.dat')
	    OPEN(2,file='o3_avk_lat_05.dat')
	ELSEIF (ind_lat.EQ.5) THEN
	    OPEN(1,file='o3_avk_lat_05.dat')
	    OPEN(2,file='o3_avk_lat_06.dat')
	ELSEIF (ind_lat.EQ.6) THEN
	    OPEN(1,file='o3_avk_lat_06.dat')
	    OPEN(2,file='o3_avk_lat_07.dat')
	ELSEIF (ind_lat.EQ.7) THEN
	    OPEN(1,file='o3_avk_lat_07.dat')
	    OPEN(2,file='o3_avk_lat_08.dat')
	ELSEIF (ind_lat.EQ.8) THEN
	    OPEN(1,file='o3_avk_lat_08.dat')
	    OPEN(2,file='o3_avk_lat_09.dat')
	ELSEIF (ind_lat.EQ.9) THEN
	    OPEN(1,file='o3_avk_lat_09.dat')
	    OPEN(2,file='o3_avk_lat_10.dat')
	ELSEIF (ind_lat.EQ.10) THEN
	    OPEN(1,file='o3_avk_lat_10.dat')
	    OPEN(2,file='o3_avk_lat_11.dat')
	ELSEIF (ind_lat.EQ.11) THEN
	    OPEN(1,file='o3_avk_lat_11.dat')
	    OPEN(2,file='o3_avk_lat_12.dat')
	ELSEIF (ind_lat.EQ.12) THEN
	    OPEN(1,file='o3_avk_lat_12.dat')
	    OPEN(2,file='o3_avk_lat_13.dat')
	ELSEIF (ind_lat.EQ.13) THEN
	    OPEN(1,file='o3_avk_lat_13.dat')
	    OPEN(2,file='o3_avk_lat_14.dat')
	ELSEIF (ind_lat.EQ.14) THEN
	    OPEN(1,file='o3_avk_lat_14.dat')
	    OPEN(2,file='o3_avk_lat_15.dat')
	ELSEIF (ind_lat.EQ.15) THEN
	    OPEN(1,file='o3_avk_lat_15.dat')
	    OPEN(2,file='o3_avk_lat_16.dat')
	ELSEIF (ind_lat.EQ.16) THEN
	    OPEN(1,file='o3_avk_lat_16.dat')
	    OPEN(2,file='o3_avk_lat_17.dat')
	ELSEIF (ind_lat.GE.17) THEN
	    OPEN(1,file='o3_avk_lat_17.dat')
	    OPEN(2,file='o3_avk_lat_18.dat')
	ENDIF


      
			DO i_alb=1,n_alb
				DO i_wv=1,n_wv
					DO i_month=1,n_month
	                      READ(1,*) 
						  DO i_o3=1,n_o3
						   READ(1,*) buffer(1:n_alt_p)
         o3_scdtbl(i_alb,i_wv,1,i_month,i_o3)=buffer(1)
         o3_avktbl(1:n_alt,i_alb,i_wv,1,i_month,i_o3)=buffer(2:n_alt_p) 
	                      
						  ENDDO
					ENDDO
				ENDDO
			ENDDO
	 
	    CLOSE(1)

      
			DO i_alb=1,n_alb
				DO i_wv=1,n_wv
					DO i_month=1,n_month
	                      READ(2,*) 
						  DO i_o3=1,n_o3
						   READ(2,*) buffer(1:n_alt_p)
         o3_scdtbl(i_alb,i_wv,2,i_month,i_o3)=buffer(1)
         o3_avktbl(1:n_alt,i_alb,i_wv,2,i_month,i_o3)=buffer(2:n_alt_p) 
						  ENDDO
					ENDDO
				ENDDO
			ENDDO
	 
	    CLOSE(2)

	    IF(ind_lat.LT.17) THEN
			lat_vec_work(1)=lat_vec(ind_lat)
              lat_vec_work(2)=lat_vec(ind_lat+1)
	    ELSE
	        lat_vec_work(1)=lat_vec(17)
              lat_vec_work(2)=lat_vec(18)
	    ENDIF

c Interpoaltion on the latitude

		DO i_alb=1,n_alb
			DO i_wv=1,n_wv
				DO i_month=1,n_month
						DO i_o3=1,n_o3
	    IF (o3_scdtbl(i_alb,i_wv,1,i_month,i_o3).LT.1.d17) 
     $      THEN	    
						ind_low(i_o3)=1
					ELSE
						ind_low(i_o3)=0
					ENDIF
	
          IF (o3_scdtbl(i_alb,i_wv,2,i_month,i_o3).LT.1.d17) 
     $      THEN
			ind_up(i_o3)=1
		ELSE 
              ind_up(i_o3)=0
	    ENDIF
	       DO i_alt=1,n_alt
			CALL inter(2,2,2,lat_int,lat_vec_work,
     $	o3_avktbl(i_alt,i_alb,i_wv,:,i_month,i_o3),ycalc,hh)
		o3_avktbl_lat(i_alt,i_alb,i_wv,i_month,i_o3)=ycalc
		   ENDDO
			CALL inter(2,2,2,lat_int,lat_vec_work,
     $	o3_scdtbl(i_alb,i_wv,:,i_month,i_o3),ycalc,hh)
		o3_scdtbl_lat(i_alb,i_wv,i_month,i_o3)=ycalc

          IF(lat_int.GE.0) THEN
			IF(ABS(lat_int-lat_vec(2)).LE.5) THEN
	  IF(ind_low(i_o3).EQ.1.AND.ind_up(i_o3).EQ.1) THEN
		DO i_alt=1,n_alt
			o3_avktbl_lat(i_alt,i_alb,i_wv,i_month,i_o3)=999.d0
	    ENDDO
	        o3_scdtbl_lat(i_alb,i_wv,i_month,i_o3)=999.d0
	  ELSEIF (ind_low(i_o3).EQ.1.AND.ind_up(i_o3).NE.1) THEN
	 DO i_alt=1,n_alt
	   o3_avktbl_lat(i_alt,i_alb,i_wv,i_month,i_o3)=
     $ o3_avktbl(i_alt,i_alb,i_wv,2,i_month,i_o3)
	 ENDDO
	   o3_scdtbl_lat(i_alb,i_wv,i_month,i_o3)= 
     $ o3_scdtbl(i_alb,i_wv,2,i_month,i_o3)
	  ENDIF
			ELSE
				IF(ind_low(i_o3).EQ.1) THEN
		  DO i_alt=1,n_alt
			o3_avktbl_lat(i_alt,i_alb,i_wv,i_month,i_o3)=999.d0
	      ENDDO
	        o3_scdtbl_lat(i_alb,i_wv,i_month,i_o3)=999.d0
				ENDIF
			ENDIF
		ELSE
			IF(ABS(lat_int-lat_vec(2)).LE.5) THEN
				IF(ind_up(i_o3).EQ.1) THEN
		  DO i_alt=1,n_alt
			o3_avktbl_lat(i_alt,i_alb,i_wv,i_month,i_o3)=999.d0
	      ENDDO
	        o3_scdtbl_lat(i_alb,i_wv,i_month,i_o3)=999.d0
				ENDIF
			ELSE	
	  IF(ind_low(i_o3).EQ.1.AND.ind_up(i_o3).EQ.1) THEN
		  DO i_alt=1,n_alt
			o3_avktbl_lat(i_alt,i_alb,i_wv,i_month,i_o3)=999.d0
       	  ENDDO
	        o3_scdtbl_lat(i_alb,i_wv,i_month,i_o3)=999.d0
	  ELSEIF (ind_low(i_o3).NE.1.AND.ind_up(i_o3).EQ.1) THEN
	  DO i_alt=1,n_alt
	   o3_avktbl_lat(i_alt,i_alb,i_wv,i_month,i_o3)=
     $ o3_avktbl(i_alt,i_alb,i_wv,1,i_month,i_o3)
	  ENDDO
	   o3_scdtbl_lat(i_alb,i_wv,i_month,i_o3)= 
     $ o3_scdtbl(i_alb,i_wv,1,i_month,i_o3)
				ENDIF
			ENDIF

	    ENDIF
						ENDDO
				ENDDO
			ENDDO
		ENDDO

		

C Surface albedo
C Koelemeijer et al, JGR, 108, D2, 4070, 2003
C
C Define lat_alb and long_alt vectors

      DO i=1,180
	    lat_alb_vec(i)=-89.5+1*(i-1)
	ENDDO

	DO i=1,360
	    long_alb_vec(i)=-179.5+1*(i-1)
	ENDDO

	
C load albedo data files and interpolation at the latitude and longitude of the station
          OPEN(2,file='albedo_01_494nm.dat')
		DO i=1,360
			READ(2,*) alb_mat(i,:)
		ENDDO
		CLOSE(2)
		DO i=1,360
			CALL inter(180,180,2,lat_int,lat_alb_vec,
     $		alb_mat(i,:),ycalc,hh)
			alb_mat_lat(i)=ycalc
		ENDDO
			CALL inter(360,360,2,long_int,long_alb_vec,
     $		alb_mat_lat(:),ycalc,hh)
			alb_int_1=ycalc

	    OPEN(2,file='albedo_02_494nm.dat')
	    DO i=1,360
			READ(2,*) alb_mat(i,:)
		ENDDO
		CLOSE(2)
		DO i=1,360
			CALL inter(180,180,2,lat_int,lat_alb_vec,
     $		alb_mat(i,:),ycalc,hh)
			alb_mat_lat(i)=ycalc
		ENDDO
			CALL inter(360,360,2,long_int,long_alb_vec,
     $		alb_mat_lat(:),ycalc,hh)
			alb_int_2=ycalc
	
	    OPEN(2,file='albedo_03_494nm.dat')
	    DO i=1,360
			READ(2,*) alb_mat(i,:)
		ENDDO
		CLOSE(2)
		DO i=1,360
			CALL inter(180,180,2,lat_int,lat_alb_vec,
     $		alb_mat(i,:),ycalc,hh)
			alb_mat_lat(i)=ycalc
		ENDDO
			CALL inter(360,360,2,long_int,long_alb_vec,
     $		alb_mat_lat(:),ycalc,hh)
			alb_int_3=ycalc

	    OPEN(2,file='albedo_04_494nm.dat')
   	    DO i=1,360
			READ(2,*) alb_mat(i,:)
		ENDDO
		CLOSE(2)
		DO i=1,360
			CALL inter(180,180,2,lat_int,lat_alb_vec,
     $		alb_mat(i,:),ycalc,hh)
			alb_mat_lat(i)=ycalc
		ENDDO
			CALL inter(360,360,2,long_int,long_alb_vec,
     $		alb_mat_lat(:),ycalc,hh)
			alb_int_4=ycalc
	
	    OPEN(2,file='albedo_05_494nm.dat')
	    DO i=1,360
			READ(2,*) alb_mat(i,:)
		ENDDO
		CLOSE(2)
		DO i=1,360
			CALL inter(180,180,2,lat_int,lat_alb_vec,
     $		alb_mat(i,:),ycalc,hh)
			alb_mat_lat(i)=ycalc
		ENDDO
			CALL inter(360,360,2,long_int,long_alb_vec,
     $		alb_mat_lat(:),ycalc,hh)
			alb_int_5=ycalc
	
		OPEN(2,file='albedo_06_494nm.dat')
	    DO i=1,360
			READ(2,*) alb_mat(i,:)
		ENDDO
		CLOSE(2)
		DO i=1,360
			CALL inter(180,180,2,lat_int,lat_alb_vec,
     $		alb_mat(i,:),ycalc,hh)
			alb_mat_lat(i)=ycalc
		ENDDO
			CALL inter(360,360,2,long_int,long_alb_vec,
     $		alb_mat_lat(:),ycalc,hh)
			alb_int_6=ycalc
	
	    OPEN(2,file='albedo_07_494nm.dat')
	    DO i=1,360
			READ(2,*) alb_mat(i,:)
		ENDDO
		CLOSE(2)
		DO i=1,360
			CALL inter(180,180,2,lat_int,lat_alb_vec,
     $		alb_mat(i,:),ycalc,hh)
			alb_mat_lat(i)=ycalc
		ENDDO
			CALL inter(360,360,2,long_int,long_alb_vec,
     $		alb_mat_lat(:),ycalc,hh)
			alb_int_7=ycalc
	    
		OPEN(2,file='albedo_08_494nm.dat')
	    DO i=1,360
			READ(2,*) alb_mat(i,:)
		ENDDO
		CLOSE(2)
		DO i=1,360
			CALL inter(180,180,2,lat_int,lat_alb_vec,
     $		alb_mat(i,:),ycalc,hh)
			alb_mat_lat(i)=ycalc
		ENDDO
			CALL inter(360,360,2,long_int,long_alb_vec,
     $		alb_mat_lat(:),ycalc,hh)
			alb_int_8=ycalc
	
	    OPEN(2,file='albedo_09_494nm.dat')
	    DO i=1,360
			READ(2,*) alb_mat(i,:)
		ENDDO
		CLOSE(2)
		DO i=1,360
			CALL inter(180,180,2,lat_int,lat_alb_vec,
     $		alb_mat(i,:),ycalc,hh)
			alb_mat_lat(i)=ycalc
		ENDDO
			CALL inter(360,360,2,long_int,long_alb_vec,
     $		alb_mat_lat(:),ycalc,hh)
			alb_int_9=ycalc
	
	    OPEN(2,file='albedo_10_494nm.dat')
	    DO i=1,360
			READ(2,*) alb_mat(i,:)
		ENDDO
		CLOSE(2)
		DO i=1,360
			CALL inter(180,180,2,lat_int,lat_alb_vec,
     $		alb_mat(i,:),ycalc,hh)
			alb_mat_lat(i)=ycalc
		ENDDO
			CALL inter(360,360,2,long_int,long_alb_vec,
     $		alb_mat_lat(:),ycalc,hh)
			alb_int_10=ycalc
	
	    OPEN(2,file='albedo_11_494nm.dat')
	    DO i=1,360
			READ(2,*) alb_mat(i,:)
		ENDDO
		CLOSE(2)
		DO i=1,360
			CALL inter(180,180,2,lat_int,lat_alb_vec,
     $		alb_mat(i,:),ycalc,hh)
			alb_mat_lat(i)=ycalc
		ENDDO
			CALL inter(360,360,2,long_int,long_alb_vec,
     $		alb_mat_lat(:),ycalc,hh)
			alb_int_11=ycalc
	
	    OPEN(2,file='albedo_12_494nm.dat')
      	DO i=1,360
			READ(2,*) alb_mat(i,:)
		ENDDO
		CLOSE(2)
		DO i=1,360
			CALL inter(180,180,2,lat_int,lat_alb_vec,
     $		alb_mat(i,:),ycalc,hh)
			alb_mat_lat(i)=ycalc
		ENDDO
			CALL inter(360,360,2,long_int,long_alb_vec,
     $		alb_mat_lat(:),ycalc,hh)
			alb_int_12=ycalc


C  Write parameters values in the output file
      OPEN(1,file='o3_avk_output.dat')
		WRITE(1,201) '% O3 column averaging kernels'
	    WRITE(1,202) '% Latitude ()                    : ',
     $     lat_int_out
          WRITE(1,202) '% Longitude ()                   : ',
     $     long_int_out
		WRITE(1,202) '% Wavelength (nm)                 : ', wvl_int
	
	    WRITE(1,205) '% Year Day number   O3 vertical column (DU)
     $   O3 column AVK (altitude range: 0.5-59.5km/step 1km) '


C day number loop
      DO dd=1,n_day_int
      daynb_int_out=daynb_int(dd)
	

      IF(daynb_int(dd).LT.15.d0) THEN
		daynb_int(dd)=15.d0
	ELSEIF(daynb_int(dd).GT.349.d0) THEN
	    daynb_int(dd)=349.d0
	ENDIF

	IF(albedo_flag.EQ.1) THEN

C Choose the albedo value corresponding to the day number in the input file
      IF(daynb_int(dd).GE.1.and.daynb_int(dd).LT.32) THEN
	    alb_int=alb_int_1
	ELSEIF(daynb_int(dd).GE.32.and.daynb_int(dd).LT.60) THEN
	    alb_int=alb_int_2
	ELSEIF(daynb_int(dd).GE.60.and.daynb_int(dd).LT.91) THEN
	    alb_int=alb_int_3
	ELSEIF(daynb_int(dd).GE.91.and.daynb_int(dd).LT.121) THEN
	    alb_int=alb_int_4
	ELSEIF(daynb_int(dd).GE.121.and.daynb_int(dd).LT.152) THEN
	    alb_int=alb_int_5
	ELSEIF(daynb_int(dd).GE.152.and.daynb_int(dd).LT.182) THEN
	    alb_int=alb_int_6
	ELSEIF(daynb_int(dd).GE.182.and.daynb_int(dd).LT.213) THEN
	    alb_int=alb_int_7
	ELSEIF(daynb_int(dd).GE.213.and.daynb_int(dd).LT.244) THEN
	    alb_int=alb_int_8
	ELSEIF(daynb_int(dd).GE.244.and.daynb_int(dd).LT.274) THEN
	    alb_int=alb_int_9
	ELSEIF(daynb_int(dd).GE.274.and.daynb_int(dd).LT.305) THEN
	    alb_int=alb_int_10
	ELSEIF(daynb_int(dd).GE.305.and.daynb_int(dd).LT.335) THEN
	    alb_int=alb_int_11
	ELSEIF(daynb_int(dd).GE.335) THEN
	    alb_int=alb_int_12
	ENDIF

	ENDIF
		

C     Interpolation on the day number
		DO i_alb=1,n_alb
			DO i_wv=1,n_wv
						DO i_o3=1,n_o3
	    DO i_alt=1,n_alt
          CALL SPLINE(daynb_vec,o3_avktbl_lat(i_alt,i_alb,i_wv,:,
     $	     i_o3),n_month,YWORK,Y2)
	    CALL SPLINT(daynb_vec,o3_avktbl_lat(i_alt,i_alb,i_wv,:,
     $		i_o3),Y2,n_month,daynb_int(dd),ycalc)
		o3_avktbl_dn(i_alt,i_alb,i_wv,i_o3)=ycalc
	    ENDDO
          CALL SPLINE(daynb_vec,o3_scdtbl_lat(i_alb,i_wv,:,
     $	     i_o3),n_month,YWORK,Y2)
	    CALL SPLINT(daynb_vec,o3_scdtbl_lat(i_alb,i_wv,:,
     $		i_o3),Y2,n_month,daynb_int(dd),ycalc)
		o3_scdtbl_dn(i_alb,i_wv,i_o3)=ycalc
						ENDDO
			ENDDO
		ENDDO
	

C     Interpolation on the albedo
	DO i_wv=1,n_wv
				DO i_o3=1,n_o3
	              DO i_alt=1,n_alt
					CALL inter(n_alb,n_alb,2,alb_int,alb_vec,
     $	o3_avktbl_dn(i_alt,:,i_wv,i_o3),ycalc,hh)
		o3_avktbl_alb(i_alt,i_wv,i_o3)=ycalc
	              ENDDO
					CALL inter(n_alb,n_alb,2,alb_int,alb_vec,
     $	o3_scdtbl_dn(:,i_wv,i_o3),ycalc,hh)
		o3_scdtbl_alb(i_wv,i_o3)=ycalc
				ENDDO
	ENDDO

	

c     Interpolation on the O3 slant column
      IF(inter_flag.EQ.2) THEN
c Interpolation on O3 SCD in molec/cm2
              DO i_wv=1,n_wv
  	        DO i_alt=1,n_alt
			cc=1
			DO i_o3=1,n_o3	          
				IF(o3_avktbl_alb(i_alt,i_wv,i_o3).LT.997.d0) THEN
			 o3_avk_effective(i_alt,i_wv,cc)=
     $                  o3_avktbl_alb(i_alt,i_wv,i_o3)
	            o3_scd_effective(i_wv,cc)=o3_scdtbl_alb(i_wv,i_o3)
	            cc=cc+1
				ENDIF
			ENDDO

              CALL inter(cc-1,cc-1,2,scd_int(dd),
     $	    o3_scd_effective(i_wv,1:cc-1),
     $			o3_avk_effective(i_alt,i_wv,1:cc-1),ycalc,hh)
	        o3_avk_alt(i_alt,i_wv)=ycalc
	        ENDDO
	        ENDDO
	ELSE
c	Interpolation on O3 VCD in DU
			DO i_wv=1,n_wv
			DO i_alt=1,n_alt
			cc=1
			DO i_o3=1,n_o3
                  IF(o3_avktbl_alb(i_alt,i_wv,i_o3).LT.997.d0) THEN
			o3_vcd_effective(cc)=o3_vcd(i_o3)
	        o3_avk_effective(i_alt,i_wv,cc)=
     $ o3_avktbl_alb(i_alt,i_wv,i_o3)
	            cc=cc+1
				ENDIF
			ENDDO

	       CALL inter(cc-1,cc-1,2,vcd_int(dd),
     $  o3_vcd_effective(1:cc-1),
     $  o3_avk_effective(i_alt,i_wv,1:cc-1),ycalc,hh)
             o3_avk_alt(i_alt,i_wv)=ycalc
	       ENDDO
		   ENDDO
	ENDIF


C     Interpolation on the wavelength
       DO i_alt=1,n_alt
          CALL SPLINE(wv_vec,o3_avk_alt(i_alt,:),n_wv,YWORK,Y2)
	    CALL SPLINT(wv_vec,o3_avk_alt(i_alt,:),Y2,n_wv,wvl_int,ycalc)
		o3_avk_int(i_alt)=ycalc
	 ENDDO
           
      year=INT(year_int(dd))

	
	WRITE(1,206) year,daynb_int_out,vcd_int(dd),o3_avk_int



	WRITE(*,*) year,daynb_int_out
	WRITE(*,*) ''

	ENDDO !day number loop
      
	CLOSE(1)

	

201   FORMAT(a29)
202   FORMAT(a36,F6.2)
203   FORMAT(a36,F5.1)
204   FORMAT(a36,F4.2)
205   FORMAT(a97)
206   FORMAT(I6,x,F7.2,12(x),F7.2,13(x),60(x,E10.4))


	END
C  End of interplotate_O3_AVK
*******************************************************************************
*******************************************************************************
       SUBROUTINE inter( dim, npoints, itype, arg,
     $     xarr, yarr, ynew, hh)
*
*     Interpolates at the x-point arg from x-value array xarr and
*     y-value array yarr. xarr and yarr are expected to have
*     ascending arguments
*     Input variables:
*     dim       Array dimension of xarr and yarr
*     npoints   No. points in arrays xarr and yarr
*     itype     Interpolation type (1: exponential; 2:linear)
*     arg       Interpolation argument
*     xarr      array of x values
*     yarr      array of y values
*
*     Output variables:
*     ynew      Interpolated function value at arg
*     hh        gradient or scale height value  
*
      INTEGER dim
      REAL*8  arg, hh, xarr(dim), yarr(dim), ynew
*

	 IF ( arg .LE. xarr(npoints) .AND. arg .GE. xarr(1)) THEN
         DO 10 iq = 1 , npoints-1
           IF ( arg .LT. xarr(iq+1) .AND. arg .GE. xarr(iq)) ip = iq
   10    CONTINUE
         IF ( arg .EQ. xarr(npoints)) ip = npoints-1
       ELSEIF ( arg .GT. xarr(npoints)) THEN
         ip = npoints - 1
       ELSEIF ( arg .LT. xarr(1)) THEN
         ip = 1
       ENDIF

*
*     Interpolate function value at arg from data points ip to ip+1
*
*
*     exponential interpolation
*
       IF ( itype .EQ. 1 ) THEN
          IF ( yarr(ip+1) .EQ. yarr(ip) ) THEN
             hh   = 0.0
             ynew = yarr(ip)
          ELSE
             hh   = -( xarr(ip+1) - xarr(ip) ) / 
     $            LOG( yarr(ip+1) / yarr(ip))
             ynew = yarr(ip) * EXP(- ( arg - xarr(ip) ) / hh )
          ENDIF
*
*     linear interpolation
*
       ELSEIF ( itype .EQ. 2 ) THEN
         hh = ( yarr(ip+1) - yarr(ip) ) / ( xarr(ip+1) - xarr(ip) )
         ynew = yarr(ip) + hh*( arg - xarr(ip))
*     
      ENDIF
      RETURN
      END       
C******************************************************************************
      SUBROUTINE SPLINE(X,Y,N,WORK,Y2)
C******************************************************************************
C     Routine to calculate 2.nd derivatives of tabulated function
C     Y(i)=Y(Xi), to be used for cubic spline calculation.
C     From numerical recipes in fortran, Cambridge University Press, 1992
      IMPLICIT NONE
      INTEGER N,I
      REAL(KIND=8)  X(N),Y(N),WORK(N),Y2(N)
      REAL(KIND=8)  SIG,P,QN,UN,YP1,YPN
C
      YP1=(Y(2)-Y(1))/(X(2)-X(1))
      YPN=(Y(N)-Y(N-1))/(X(N)-X(N-1))
      IF(YP1.GT.99.0E+30) THEN
          Y2(1)=0.0
          WORK(1)=0.0
      ELSE
          Y2(1)=-0.5E0
          WORK(1)=(3.0E0/(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)
      ENDIF
      DO I=2,N-1
          SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))
          P=SIG*Y2(I-1)+2.0E0
          Y2(I)=(SIG-1.0E0)/P
          WORK(I)=(6.0E0*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     +             /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*WORK(I-1))/P
      ENDDO
      IF(YPN.GT.99.0E+30) THEN
          QN=0.0
          UN=0.0
      ELSE
          QN=0.5E0
          UN=(3.0E0/(X(N)-X(N-1)))*(YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))
      ENDIF
      Y2(N)=(UN-QN*WORK(N-1))/(QN*Y2(N-1)+1.0E0)
      DO I=N-1,1,-1
          Y2(I)=Y2(I)*Y2(I+1)+WORK(I)
      ENDDO
C
      RETURN
      END
C
C******************************************************************************
      SUBROUTINE SPLINT(XA,YA,Y2A,N,X,Y)
C******************************************************************************
C     Cubic spline calculation
C     From numerical recipes in fortran, Cambridge University Press, 1992
      IMPLICIT NONE
      INTEGER KLO,KHI,N,K
      REAL(KIND=8)  XA(N),YA(N),Y2A(N)
      REAL(KIND=8)  X,Y,H,A,B
C
      KLO=1
      KHI=N
 1    IF(KHI-KLO.GT.1) THEN
          K=(KHI+KLO)/2
          IF(XA(K).GT.X) THEN
              KHI=K
          ELSE
              KLO=K
          ENDIF
          GOTO 1
      ENDIF
      H=XA(KHI)-XA(KLO)
      A=(XA(KHI)-X)/H
      B=(X-XA(KLO))/H
      Y=A*YA(KLO)+B*YA(KHI)+
     +        ((A**3-A)*Y2A(KLO)+(B**3-B)*Y2A(KHI))*(H**2)/6.0E0
C
      RETURN
      END
